static u32
ft_is_format(const char c) {
	return (c == 'c' || c == 's' || c == 'p' || c == 'i' || c == 'd'
		|| c == 'u' || c == 'x' || c == 'X' || c == '%' || c == 'b');
}

static u32
ft_post_character(u32 fd, char format, va_list args) {
    if (format == 'c')
        return ft_putchar_fd(va_arg(args, int), fd);
    else if (format == 's')
        return ft_putstr_fd(va_arg(args, char *), fd);
    else if (format == 'd' || format == 'i' || format == 'u')
        return ft_putnbr_fd(va_arg(args, i64), fd);
    else if (format == 'x')
        return ft_putnbrhex_fd(va_arg(args, u32), fd);
    else if (format == 'X')
        return ft_putnbrhex_upper_fd(va_arg(args, u32), fd);
    else if (format == '%')
        return ft_putchar_fd('%', fd);
    else if (format == 'p')
        return ft_putvd_fd(va_arg(args, void *), fd);
    else if (format == 'b')
        return ft_putstr_fd(va_arg(args, i32) ? "true" : "false", fd); 
    return 0;
}

u32
ft_vdprintf(u32 fd, const char *str, va_list args) {
	u32 count = 0;

	if (str == NULL)
		return (-1);
    for (u32 i = 0; str[i]; i++) {
		if (str[i] == '%' && ft_is_format(str[i + 1]))
			count += ft_post_character(fd, str[(i++) + 1], args);
		else {
			ft_putchar_fd(str[i], fd);
			count++;
		}
	}
	return (count);
}

u32
ft_printf_fd(u32 fd, const char *str, ...) {
	va_list	args;
	va_start(args, str);
    u32 count = ft_vdprintf(fd, str, args);
	va_end(args);
    return count;
}

u32
ft_printf(const char *str, ...) {
	va_list	args;
	va_start(args, str);
    u32 count = ft_vdprintf(1, str, args);
	va_end(args);
    return count;
}

