#pragma once

# include <stdlib.h>
# include <unistd.h>
# include <stdint.h>
# include <inttypes.h>
# include <stdarg.h>

typedef struct s_list
{
	void			*content;
	struct s_list	*next;
}	t_list;

#define MAX(X, Y) ((X) > (Y) ? (X) : (Y))
#define MIN(X, Y) ((X) < (Y) ? (X) : (Y))
#define ABS(X) ((X) >= 0 ? (X) : -(X))

typedef uint8_t u8;
typedef uint16_t u16;
typedef uint32_t u32;
typedef uint64_t u64;
typedef int8_t i8;
typedef int16_t i16;
typedef int32_t i32;
typedef int64_t i64;
typedef float f32;
typedef double f64;

i32		ft_isalpha(char c);
i32		ft_isdigit(char c);
i32		ft_isalnum(char c);
i32		ft_isascii(char c);
i32		ft_isprint(char c);
i32		ft_toupper(char c);
i32		ft_tolower(char c);
size_t	ft_strlen(const char *str);
void	*ft_memset(void *ptr, i32 v, size_t count);
void	ft_bzero(void *s, u32 n);
void	*ft_memcpy(void *dest, const void *src, size_t s);
void	*ft_memmove(void *dest, const void *src, size_t s);
void	*ft_memchr(const void *memory_block, i32 searched_char, size_t size);
i32		ft_memcmp(const void *pointer1, const void *pointer2, size_t size);
char    *ft_strcpy(char *dest, const char *src);
u32     ft_strlcpy(char *dest, const char *src, u32 size);
char	*ft_strnstr(const char *big, const char *little, size_t len);
char	*ft_strchr(const char *str, i32 search);
char	*ft_strrchr(const char *str, i32 search);
i32     ft_strcmp(const char *s1, const char *s2);
i32		ft_strncmp(const char *s1, const char *s2, u32 n);
char *	ft_strcat(char *dest, const char *src);
size_t	ft_strlcat(char *dest, const char *src, size_t size);
char 	*ft_strlcats(u32 nbr_str, ...);
char	*ft_strdup(const char *src);
i32		ft_atoi(const char *nptr);
char	**ft_split(char const *s, char c);
void	*ft_calloc(size_t nitems, size_t size);
char	*ft_itoa(i32 n);
char	*ft_strmapi(char const *s, char (*f)(u32, char));
void	ft_striteri(char *s, void (*f)(u32, char*));
i32 	ft_putchar_fd(char c, i32 fd);
i32     ft_putstr_fd(char *s, i32 fd);
void	ft_putendl_fd(char *s, i32 fd);
u32     ft_putnbr_fd(i64 n, i32 fd);
i32		ft_get_size(i64 n);
i32		ft_power(i32 nb, i32 power);
char	*ft_strjoin(char const *s1, char const *s2);
char	*ft_strtrim(char const *s1, char const *set);
char	*ft_substr(char const *s, u32 start, size_t len);
t_list	*ft_lstnew(void *content);
void	ft_lstadd_front(t_list **lst, t_list *new);
void	ft_lstadd_back(t_list **lst, t_list *new);
i32		ft_lstsize(t_list *lst);
t_list	*ft_lstlast(t_list *lst);
void	ft_lstdelone(t_list *lst, void (*del)(void*));
void	ft_lstclear(t_list **lst, void (*del)(void*));
void	ft_lstiter(t_list *lst, void (*f)(void *));
t_list	*ft_lstmap(t_list *lst, void *(*f)(void *), void (*del)(void *));
void	ft_lstremove_front(t_list **lst, void (*del)(void*));
void	ft_lstremove_back(t_list **lst, void (*del)(void*));
i32	    ft_atoi_check(const char *nptr);
u32     ft_strslen(char **strs);
